# debug info seem not works with D compiler
%global debug_package %{nil}

%global major_version 0
%global minor_version 4
%global patch_version 0
#%%global pre beta

Name:           dsymbol
Version:        %{major_version}.%{minor_version}.%{patch_version}
Release:        1%{?pre:.%{pre}}%{?dist}
Summary:        Symbol lookup support for libdparse
summary(fr):    Support pour la recherche de symbol avec libdparse
License:        Boost
URL:            https://github.com/dlang-community/dsymbol

# curl -Lodsymbol-%%{version}%%{?pre:-%%{pre}}.tar.gz https://github.com/dlang-community/dsymbol/archive/v%%{version}%%{?pre:-%%{pre}}.tar.gz
Source0:        %{name}-%{version}%{?pre:-%{pre}}.tar.gz
ExclusiveArch:  %{ldc_arches}

BuildRequires:  ldc libdparse-devel containers-devel
Requires:       ldc-phobos ldc-druntime libdparse containers

%description
Symbol lookup support for libdparse.

%description -l fr
Prise en charge de la recherche de symbole pour libdparse.

%package        devel
Summary:        Development files for %{name}
Summary(fr):    Fichiers de développement pour %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
dsymbol-devel package contains header files for developing D applications
that use msgpack-d.

%description devel -l fr
Le paquet dsymbol-devel contient les fichiers d'entêtes pour développer
des applications en D utilisant dsymbol.


%package geany-tags
Summary:        Support for enable autocompletion in geany
Summary(fr):    Support pour activer l'auto-complétion dans geany
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch
BuildRequires:  geany
Requires:       geany

%description geany-tags
Enable autocompletion for dsymbol library in geany (IDE)

%description -l fr geany-tags
Active l'autocompletion pour pour la bibliothèque dsymbol dans geany (IDE)

%prep
%setup -q -n %{name}-%{version}%{?pre:-%{pre}}
# temp geany config directory for allow geany to generate tags
mkdir geany_config

echo "# Package Information for pkg-config
# Created: $(date)
# Licence: Boost
prefix=%{_prefix}
exec_prefix=%{_prefix}
libdir=%{_libdir}
includedir=%{_d_includedir}/
Name: %{name}
Description: Symbol lookup support for libdparse.
Version: %{version}
Libs: -L-l%{name}
Cflags: -I %{_d_includedir}/%{name} ${DFLAGS}" > %{name}.pc


%build
DFLAGS='-w -release -g -O2'
src_dir='src'
sources=$(find "${src_dir}" -name '*.d')
LIBS='-L-ldl -L-ldruntime-ldc-shared  -L-lphobos2-ldc-shared -L-ldparse -L-lcontainers'
mkdir build
for f in ${sources[@]}; do
    d_path=$(dirname ${f});
    d_file=$(basename ${f});
    header_file=include/${d_path/${src_dir}}/${d_file/.d/.di}
    doc_file=html/${d_path/${src_dir}}/${d_file/.d/.html}
    object_file=build/${d_path/${src_dir}}/${d_file/.d/.o}
    # generate header
    ldc2 -I "${src_dir}" -o- -c $f -Hf ${header_file};
    # generate doc
    ldc2 -I "${src_dir}" -o- -c $f -Df ${doc_file};
    # generate object
    ldc2 -I "${src_dir}" ${DFLAGS} -c -relocation-model=pic $f -of ${object_file}
done
# generate library
objects=$(find build -name '*.o')
ldc2 ${LIBS} -shared -soname lib%{name}.so.%{major_version} -of./lib/lib%{name}.so.%{version} ${objects}
# generate geany tags
headers=$(find src -name '*.d')
geany -c geany_config -g %{name}.d.tags ${headers[@]} 

%install
mkdir -p %{buildroot}/{%{_libdir},%{_d_includedir}/%{name},%{_datadir}/geany/tags/}

# header files
# FIXME: https://github.com/ldc-developers/ldc/issues/2797
#cp -r include/%{name} %{buildroot}/%{_d_includedir}/
cp -r src/%{name} %{buildroot}/%{_d_includedir}/

# shared library
install -m0755 lib/lib%{name}.so.%{version} %{buildroot}/%{_libdir}
pushd %{buildroot}/%{_libdir}
    ln -s lib%{name}.so.%{version} lib%{name}.so.%{major_version}
    ln -s lib%{name}.so.%{major_version} lib%{name}.so
popd

# doc
install -d %{buildroot}/%{_datadir}/doc/%{name}/
cp -r html %{buildroot}/%{_datadir}/doc/%{name}/

# geany tags
install -m0644 %{name}.d.tags %{buildroot}/%{_datadir}/geany/tags/

# pkgconfig
install -d %{buildroot}/%{_datadir}/pkgconfig
install -m 0644 %{name}.pc %{buildroot}/%{_datadir}/pkgconfig

%ldconfig_scriptlets

%files
%license LICENSE_1_0.txt
%doc README.md
%{_libdir}/lib%{name}.so.%{version}
%{_libdir}/lib%{name}.so.%{major_version}

%files devel
%{_datadir}/doc/%{name}/html/
%{_datadir}/pkgconfig/%{name}.pc
%{_includedir}/d/%{name}
%{_libdir}/lib%{name}.so

%files geany-tags
%{_datadir}/geany/tags/%{name}.d.tags


%changelog
* Thu Aug  2 2018 MERCIER Jonathan <bioinfornatics at gmail.com> - 0.4.0-1
- Initial release
